/*******************************************************************************
 *    : HelloWin.C
 *    : C ü
 *    : WinMain - Win32 Entry Point.
 *          WndProc - Windows Procedure.
 *    :    GUI ø̼ ...
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.11.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
#include <windows.h>

typedef void (WINAPI *PFN_DRAWTEXTPOS04  )(HDC, LPTSTR, POINT);
typedef SIZE (WINAPI *PFN_CALCTESTWIDTH06)(HDC hDC, LPTSTR szText);
typedef BOOL (WINAPI *PFN_ISPOINTINRECT11)(RECT rcRgn, POINT ptPos);

PFN_DRAWTEXTPOS04	g_pfnDrawTextPos04	 = NULL;
PFN_CALCTESTWIDTH06 g_pfnCalcTextWidth06 = NULL;
PFN_ISPOINTINRECT11 g_pfnIsPointInRect11 = NULL;

TCHAR	g_szAppName[] = TEXT("GUI Application using Explicit DLL Loading...");
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);


#define USE_DECLSPEC

/*******************************************************************************
 *    : WIN32 Ʈ Ʈ c
 *    : 
 *    : WinMain
 *    : HINSTANCE hInstance [IN] :  μ νϽ ڵ(۹)
 *          HINSTANCE hPrevInst [IN] :  0, (16Ʈ ȣȯ )
 *          PSTR      szCmdLine [IN] : Ŀǵ  з
 *          int       iCmdShow  [IN] : 찡  
 *   ȯ : int : 
 *    : WIN32 Ʈ Ʈ c
 *          ܼ α׷(main) ٸ GUI WinMain Ʈ Ʈ
 *          Լ νѴ.
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst,
                   PSTR szCmdLine, int iCmdShow)
{
#ifdef USE_DECLSPEC
	HMODULE hDll = LoadLibrary("../../Chap_04/DllBasic/DllBasicDecl/Debug/DllBasic.dll");
	if(!hDll)
	{
		MessageBox(NULL, "DllBasic.dll ε ߽ϴ.", "", MB_OK);
		return 1;
	}
	g_pfnDrawTextPos04	 = (PFN_DRAWTEXTPOS04  )GetProcAddress(hDll, "_DrawTextPos04@16"  );
	g_pfnCalcTextWidth06 = (PFN_CALCTESTWIDTH06)GetProcAddress(hDll, "_CalcTextWidth06@24");
	g_pfnIsPointInRect11 = (PFN_ISPOINTINRECT11)GetProcAddress(hDll, "_IsPointInRect11@8");
#else
	HMODULE hDll = LoadLibrary("../../Chap_04/DllBasic/DllBasicDef/Debug/DllBasic.dll");
	if(!hDll)
	{
		MessageBox(NULL, "DllBasic.dll ε ߽ϴ.", "", MB_OK);
		return 1;
	}
	g_pfnDrawTextPos04	 = (PFN_DRAWTEXTPOS04  )GetProcAddress(hDll, "DrawTextPos04"  );
	g_pfnCalcTextWidth06 = (PFN_CALCTESTWIDTH06)GetProcAddress(hDll, "CalcTextWidth06");
	g_pfnIsPointInRect11 = (PFN_ISPOINTINRECT11)GetProcAddress(hDll, "IsPointInRect11");
#endif
	if(!g_pfnCalcTextWidth06)
		MessageBox(NULL, "Լ CalcTextWidth06 ȹ  ϴ.", "", MB_OK);
	if(!g_pfnDrawTextPos04  )
		MessageBox(NULL, "Լ DrawTextPos04 ȹ  ϴ.", "", MB_OK);
	if(!g_pfnIsPointInRect11)
		MessageBox(NULL, "Լ g_pfnIsPointInRect11 ȹ  ϴ.", "", MB_OK);


	HWND         hWnd;
	MSG          msg;
	WNDCLASS     wndclass;

	////////////////////////////////////////////////////////////////////////////
	// Ŭ 
	////////////////////////////////////////////////////////////////////////////
	wndclass.style         = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = g_szAppName;

	if(!RegisterClass(&wndclass))
	{
		MessageBox(NULL, TEXT("This program requires Windows NT!"),
				  g_szAppName, MB_ICONERROR) ;
		return 0 ;
	}
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// 
	////////////////////////////////////////////////////////////////////////////
	hWnd = CreateWindow(g_szAppName,				// window class name
						g_szAppName,				// window caption
						WS_OVERLAPPEDWINDOW,		// window style
						CW_USEDEFAULT,              // initial x position
						CW_USEDEFAULT,              // initial y position
						400,						// initial x size
						150,						// initial y size
						NULL,                       // parent window handle
						NULL,                       // window menu handle
						hInstance,                  // program instance handle
						NULL) ;                     // creation parameters
	if(!hWnd)
	{
		MessageBox(NULL, TEXT("Window Creation Failure!!!"),
				  g_szAppName, MB_ICONERROR) ;
		return 0 ;
	}
	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	//޽ 
	////////////////////////////////////////////////////////////////////////////
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	////////////////////////////////////////////////////////////////////////////

	if(hDll)
		FreeLibrary(hDll);

	return msg.wParam;
}
////////////////////////////////////////////////////////////////////////////////

HANDLE	g_hThreads[10];
HANDLE	g_hEvents[10];
int		g_nThreadCnt;

DWORD WINAPI ThreadStartUp(LPVOID pParam)
{
	int nIndex = (int)pParam;

	WaitForSingleObject(g_hEvents[nIndex], INFINITE);
	CloseHandle(g_hEvents[nIndex]);
	g_hEvents[nIndex] = NULL;

	return 0;
}

/*******************************************************************************
 *    :  ν Լ(ݹ Լ)
 *    : 
 *    : WndProc
 *    : HWND   hWnd   [IN] : ޽   ڵ
 *          UINT   uMsg   [IN] : ޽
 *          WPARAM wParam [IN] : 1
 *          LPARAM lParam [IN] : 2
 *   ȯ : LRESULT : 
 *    :  ν
 *          WINDOWCLASS lpfnWndProc ʵ忡  Լ  ؾ Ѵ.
 *             Լ  ƮѴ.
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HDC         hDC;
	PAINTSTRUCT ps;
	RECT        rc;
	static char szOutBuf[] = 
		TEXT("The Most Simple Windows GUI Program by YHD.");

	switch(uMsg)
	{
		case WM_LBUTTONDOWN	:
		{
			if(!g_pfnDrawTextPos04)
				return 0;

			HDC hDC = GetDC(hWnd);
			POINT pt;
			pt.x = LOWORD(lParam), pt.y = HIWORD(lParam);
			g_pfnDrawTextPos04(hDC, szOutBuf, pt);
			ReleaseDC(hWnd, hDC);
		}
		return 0;

		case WM_RBUTTONDOWN	:
		{
			if(!g_pfnCalcTextWidth06)
				return 0;

			HDC hDC = GetDC(hWnd);
			SIZE si = g_pfnCalcTextWidth06(hDC, szOutBuf);
			TCHAR szMsg[128];
			wsprintf(szMsg, 
				TEXT("Width : %d, Height : %d pixels"), si.cx, si.cy);
			MessageBox(hWnd, szMsg, g_szAppName, MB_OK|MB_ICONINFORMATION);
			ReleaseDC(hWnd, hDC);
		}
		return 0;

		case WM_PAINT:
			hDC = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rc);
			DrawText(hDC, 
					 szOutBuf, 
					 lstrlen(szOutBuf), 
					 &rc, 
					 DT_SINGLELINE|DT_CENTER|DT_VCENTER);
			EndPaint (hWnd, &ps) ;
		return 0;

		case WM_DESTROY:
			PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
////////////////////////////////////////////////////////////////////////////////