/*******************************************************************************
 *    : HelloWin.C
 *    : C ü
 *    : WinMain - Win32 Entry Point.
 *          WndProc - Windows Procedure.
 *    :    GUI ø̼ ...
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.11.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
#include <windows.h>

TCHAR	g_szAppName[] = TEXT("GUI Application using MyGetProcAddress...");
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);


/*******************************************************************************
 *    : WIN32 Ʈ Ʈ c
 *    : 
 *    : WinMain
 *    : HINSTANCE hInstance [IN] :  μ νϽ ڵ(۹)
 *          HINSTANCE hPrevInst [IN] :  0, (16Ʈ ȣȯ )
 *          PSTR      szCmdLine [IN] : Ŀǵ  з
 *          int       iCmdShow  [IN] : 찡  
 *   ȯ : int : 
 *    : WIN32 Ʈ Ʈ c
 *          ܼ α׷(main) ٸ GUI WinMain Ʈ Ʈ
 *          Լ νѴ.
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst,
                   PSTR szCmdLine, int iCmdShow)
{
	HWND         hWnd;
	MSG          msg;
	WNDCLASS     wndclass;

	////////////////////////////////////////////////////////////////////////////
	// Ŭ 
	////////////////////////////////////////////////////////////////////////////
	wndclass.style         = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = g_szAppName;

	if(!RegisterClass(&wndclass))
	{
		MessageBox(NULL, TEXT("This program requires Windows NT!"),
				  g_szAppName, MB_ICONERROR) ;
		return 0 ;
	}
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// 
	////////////////////////////////////////////////////////////////////////////
	hWnd = CreateWindow(g_szAppName,				// window class name
						g_szAppName,				// window caption
						WS_OVERLAPPEDWINDOW,		// window style
						CW_USEDEFAULT,              // initial x position
						CW_USEDEFAULT,              // initial y position
						400,						// initial x size
						150,						// initial y size
						NULL,                       // parent window handle
						NULL,                       // window menu handle
						hInstance,                  // program instance handle
						NULL) ;                     // creation parameters
	if(!hWnd)
	{
		MessageBox(NULL, TEXT("Window Creation Failure!!!"),
				  g_szAppName, MB_ICONERROR) ;
		return 0 ;
	}
	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	//޽ 
	////////////////////////////////////////////////////////////////////////////
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	////////////////////////////////////////////////////////////////////////////

	return msg.wParam;
}
////////////////////////////////////////////////////////////////////////////////


typedef void (WINAPI *PFN_DRAWTEXTPOS04  )(HDC, LPTSTR, POINT);
typedef SIZE (WINAPI *PFN_CALCTESTWIDTH06)(HDC hDC, LPTSTR szText);
typedef BOOL (WINAPI *PFN_ISPOINTINRECT11)(RECT rcRgn, POINT ptPos);

FARPROC MyGetProcAddress(HINSTANCE hMod, LPSTR pszSymbol);

/*******************************************************************************
 *    :  ν Լ(ݹ Լ)
 *    : 
 *    : WndProc
 *    : HWND   hWnd   [IN] : ޽   ڵ
 *          UINT   uMsg   [IN] : ޽
 *          WPARAM wParam [IN] : 1
 *          LPARAM lParam [IN] : 2
 *   ȯ : LRESULT : 
 *    :  ν
 *          WINDOWCLASS lpfnWndProc ʵ忡  Լ  ؾ Ѵ.
 *             Լ  ƮѴ.
 * ----------------------------------------------------------------------------
 *    : Yi HoDong
 *   ¥ : 2001.08.06
 *    : 1.0
 * ȸ   : YHD Works Co. (http://www.yhdworks.com)
 ******************************************************************************/
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HMODULE				hDll = NULL;
	static PFN_DRAWTEXTPOS04	pfnDrawTextPos04 = NULL;
	static PFN_CALCTESTWIDTH06	pfnCalcTextWidth06 = NULL;
	static CHAR	szOutBuf[] = "The Most Simple Windows GUI Program by YHD.";

	HDC         hDC;
	PAINTSTRUCT ps;
	RECT        rc;

	switch(uMsg)
	{
		case WM_CREATE		:
		{
			hDll = LoadLibrary("DllBasicNoOrd.dll");
			if(!hDll)
			{
				MessageBox(NULL, 
				"DllBasic.dll ε ߽ϴ.", "", MB_OK);
				return 0;
			}

			pfnDrawTextPos04 = (PFN_DRAWTEXTPOS04)
								MyGetProcAddress(hDll, MAKEINTRESOURCE(4));
								//MyGetProcAddress(hDll, "DrawTextPos04"  );
			if(!pfnDrawTextPos04)
				MessageBox(NULL, 
				"Լ DrawTextPos04 ȹ  ϴ.", "", MB_OK);
			pfnCalcTextWidth06 = (PFN_CALCTESTWIDTH06)
								MyGetProcAddress(hDll, MAKEINTRESOURCE(6));
								//MyGetProcAddress(hDll, "CalcTextWidth06");
			if(!pfnCalcTextWidth06)
				MessageBox(NULL, 
				"Լ CalcTextWidth06 ȹ  ϴ.", "", MB_OK);
		}
		return 0;

		case WM_LBUTTONDOWN	:
		{
			if(!pfnDrawTextPos04)
				return 0;

			HDC hDC = GetDC(hWnd);
			POINT pt;
			pt.x = LOWORD(lParam), pt.y = HIWORD(lParam);
			pfnDrawTextPos04(hDC, szOutBuf, pt);
			ReleaseDC(hWnd, hDC);
		}
		return 0;

		case WM_RBUTTONDOWN	:
		{
			if(!pfnCalcTextWidth06)
				return 0;

			HDC hDC = GetDC(hWnd);
			SIZE si = pfnCalcTextWidth06(hDC, szOutBuf);
			TCHAR szMsg[128];
			wsprintf(szMsg, 
				TEXT("Width : %d, Height : %d pixels"), si.cx, si.cy);
			MessageBox(hWnd, szMsg, g_szAppName, MB_OK|MB_ICONINFORMATION);
			ReleaseDC(hWnd, hDC);
		}
		return 0;

		case WM_PAINT:
			hDC = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rc);
			DrawText(hDC, 
					 szOutBuf, 
					 lstrlen(szOutBuf), 
					 &rc, 
					 DT_SINGLELINE|DT_CENTER|DT_VCENTER);
			EndPaint (hWnd, &ps) ;
		return 0;

		case WM_DESTROY:
		{
			if(hDll)
				FreeLibrary(hDll);

			PostQuitMessage(0);
		}
		return 0;
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

FARPROC MyGetProcAddress(HINSTANCE hMod, LPSTR pszSymbol)
{
	LPBYTE  pImageBase = (LPBYTE)hMod;
	if(!pImageBase)
		return NULL;

	PIMAGE_DOS_HEADER pIDH = (PIMAGE_DOS_HEADER)pImageBase;
	if(pIDH->e_magic != IMAGE_DOS_SIGNATURE)
		return NULL;

	PIMAGE_NT_HEADERS pINH = (PIMAGE_NT_HEADERS)(pImageBase + pIDH->e_lfanew);
	if(pINH->Signature != IMAGE_NT_SIGNATURE)
		return NULL;

	PIMAGE_DATA_DIRECTORY pIDD = &pINH->
		OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT];
	PIMAGE_EXPORT_DIRECTORY pIED = 
		(PIMAGE_EXPORT_DIRECTORY)(pImageBase + pIDD->VirtualAddress);

	DWORD dwFuncIndex = 0;
	LPWORD	pwOrdTbl = (LPWORD )(pImageBase + pIED->AddressOfNameOrdinals);
	LPDWORD pFuncTbl = (LPDWORD)(pImageBase + pIED->AddressOfFunctions);
	if(pszSymbol > (LPSTR)0xFFFF)
	{
		LPDWORD pFuncNameTbl = (LPDWORD)(pImageBase + pIED->AddressOfNames);
		for(; dwFuncIndex < pIED->NumberOfNames; dwFuncIndex++)
		{
			LPSTR pFuncName = (LPSTR)(pImageBase + pFuncNameTbl[dwFuncIndex]);
			if(!strcmp(pszSymbol, pFuncName))
				return (FARPROC)(pImageBase + pFuncTbl[pwOrdTbl[dwFuncIndex]]);
		}
	}
	else
	{
		dwFuncIndex = (DWORD)((WORD)pszSymbol - pIED->Base);
		if(dwFuncIndex < pIED->NumberOfFunctions)
			return (FARPROC)(pImageBase + pFuncTbl[dwFuncIndex]);
	}

	return NULL;
}
////////////////////////////////////////////////////////////////////////////////